summaryrefslogtreecommitdiff
path: root/tests/subobj11c.test
diff options
context:
space:
mode:
authorStefano Lattarini <stefano.lattarini@gmail.com>2010-05-14 21:19:32 +0200
committerStefano Lattarini <stefano.lattarini@gmail.com>2010-12-23 20:31:41 +0100
commit20fb9cebd5ca7c48c0eeba32d6ea42bab1f5b912 (patch)
tree87de0ecb1ba10935cc1b2953240bbb85c0712ffc /tests/subobj11c.test
parent9552ab180a2ecbccd8a2439ad860838a497315aa (diff)
downloadautomake-20fb9cebd5ca7c48c0eeba32d6ea42bab1f5b912.tar.gz
Work around a bug in file-inclusion mechanism of Solaris make.
* automake.in (handle_single_transform): In the name of the dependency file: collapse multiple slash characters into a single one. * tests/subobj11a.test: New test. * tests/subobj11b.test: Likewise. * tests/subobj11c.test: Likewise. * tests/depcomp8a.test: Likewise. * tests/depcomp8b.test: Likewise. * tests/Makefile.am (TESTS): Updated. * NEWS: Updated. Report by Stefano Lattarini, quick fix by Ralf Wildenhues, final patch and tests by Stefano Lattarini.
Diffstat (limited to 'tests/subobj11c.test')
-rwxr-xr-xtests/subobj11c.test53
1 files changed, 53 insertions, 0 deletions
diff --git a/tests/subobj11c.test b/tests/subobj11c.test
new file mode 100755
index 000000000..9262d155f
--- /dev/null
+++ b/tests/subobj11c.test
@@ -0,0 +1,53 @@
+#! /bin/sh
+# Copyright (C) 2010 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+# Automatic dependency tracking with subdir-objects option active:
+# check for a pathological case of slash-collapsing in the name of
+# included makefile fragments (containing dependency info).
+# See also related tests `subobj11a.test' and `subobj11b.test'
+
+. ./defs || Exit 1
+
+set -e
+
+cat >> configure.in << 'END'
+AC_PROG_CC
+AM_PROG_CC_C_O
+END
+
+cat > Makefile.am << 'END'
+AUTOMAKE_OPTIONS = subdir-objects
+bin_PROGRAMS = foo
+foo_SOURCES = //zardoz.c
+END
+
+$ACLOCAL
+$AUTOMAKE -a
+
+#
+# This check depends on automake internals, but presently this is
+# the only way to test the code path we are interested in.
+# Please update these checks when (and if) the relevant automake
+# internals are changed.
+#
+# Be a little lax in the regexp, to account for automake conditionals,
+# quoting, and similar stuff.
+#
+# FIXME: Are we sure this is the most sensible output in our situation?
+#
+grep '^[^/]*am__include[^/]*//\$(DEPDIR)/zardoz\.[^/]*$' Makefile.in
+
+: